Index: src/includes/classes/Smarty/sysplugins/smarty_resource.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_resource.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_resource.php	(revision )
@@ -532,381 +261,10 @@
      *
      * @return Smarty_Template_Source   Source Object
      */
-    public static function source(Smarty_Internal_Template $_template = null, Smarty $smarty = null, $template_resource = null)
+    public static function source(Smarty_Internal_Template $_template = null, Smarty $smarty = null,
+                                  $template_resource = null)
     {
-        if ($_template) {
-            $smarty = $_template->smarty;
-            $template_resource = $_template->template_resource;
+        return Smarty_Template_Source::load($_template, $smarty, $template_resource);
-        }
+    }
-
-        // parse resource_name, load resource handler, identify unique resource name
-        self::parseResourceName($template_resource, $smarty->default_resource_type, $name, $type);
-        $resource = Smarty_Resource::load($smarty, $type);
-        // go relative to a given template?
-        $_file_is_dotted = isset($name[0]) && $name[0] == '.' && ($name[1] == '.' || $name[1] == '/' || $name[1] == "\\");
-        if ($_file_is_dotted && isset($_template) && $_template->parent instanceof Smarty_Internal_Template && ($_template->parent->source->type == 'file' || $_template->parent->source->type == 'extends')) {
-            $name2 = dirname($_template->parent->source->filepath) . DS . $name;
-        } else {
-            $name2 = $name;
-        }
+}
-        $unique_resource_name = $resource->buildUniqueResourceName($smarty, $name2);
 
-        // check runtime cache
-        $_cache_key = 'template|' . $unique_resource_name;
-        if ($smarty->compile_id) {
-            $_cache_key .= '|' . $smarty->compile_id;
-        }
-        if (isset(self::$sources[$_cache_key])) {
-            return self::$sources[$_cache_key];
-        }
-
-        // create source
-        $source = new Smarty_Template_Source($resource, $smarty, $template_resource, $type, $name, $unique_resource_name);
-        $resource->populate($source, $_template);
-
-        // runtime cache
-        self::$sources[$_cache_key] = $source;
-
-        return $source;
-    }
-
-    /**
-     * initialize Config Source Object for given resource
-     *
-     * @param  Smarty_Internal_Config $_config config object
-     *
-     * @throws SmartyException
-     * @return Smarty_Config_Source   Source Object
-     */
-    public static function config(Smarty_Internal_Config $_config)
-    {
-        static $_incompatible_resources = array('eval' => true, 'string' => true, 'extends' => true, 'php' => true);
-        $config_resource = $_config->config_resource;
-        $smarty = $_config->smarty;
-
-        // parse resource_name
-        self::parseResourceName($config_resource, $smarty->default_config_type, $name, $type);
-
-        // make sure configs are not loaded via anything smarty can't handle
-        if (isset($_incompatible_resources[$type])) {
-            throw new SmartyException ("Unable to use resource '{$type}' for config");
-        }
-
-        // load resource handler, identify unique resource name
-        $resource = Smarty_Resource::load($smarty, $type);
-        $unique_resource_name = $resource->buildUniqueResourceName($smarty, $name, true);
-
-        // check runtime cache
-        $_cache_key = 'config|' . $unique_resource_name;
-        if (isset(self::$sources[$_cache_key])) {
-            return self::$sources[$_cache_key];
-        }
-
-        // create source
-        $source = new Smarty_Config_Source($resource, $smarty, $config_resource, $type, $name, $unique_resource_name);
-        $resource->populate($source, null);
-
-        // runtime cache
-        self::$sources[$_cache_key] = $source;
-
-        return $source;
-    }
-}
-
-/**
- * Smarty Resource Data Object
- * Meta Data Container for Template Files
- *
- * @package    Smarty
- * @subpackage TemplateResources
- * @author     Rodney Rehm
- * @property integer $timestamp Source Timestamp
- * @property boolean $exists    Source Existence
- * @property boolean $template  Extended Template reference
- * @property string  $content   Source Content
- */
-class Smarty_Template_Source
-{
-    /**
-     * Name of the Class to compile this resource's contents with
-     *
-     * @var string
-     */
-    public $compiler_class = null;
-
-    /**
-     * Name of the Class to tokenize this resource's contents with
-     *
-     * @var string
-     */
-    public $template_lexer_class = null;
-
-    /**
-     * Name of the Class to parse this resource's contents with
-     *
-     * @var string
-     */
-    public $template_parser_class = null;
-
-    /**
-     * Unique Template ID
-     *
-     * @var string
-     */
-    public $uid = null;
-
-    /**
-     * Template Resource (Smarty_Internal_Template::$template_resource)
-     *
-     * @var string
-     */
-    public $resource = null;
-
-    /**
-     * Resource Type
-     *
-     * @var string
-     */
-    public $type = null;
-
-    /**
-     * Resource Name
-     *
-     * @var string
-     */
-    public $name = null;
-
-    /**
-     * Unique Resource Name
-     *
-     * @var string
-     */
-    public $unique_resource = null;
-
-    /**
-     * Source Filepath
-     *
-     * @var string
-     */
-    public $filepath = null;
-
-    /**
-     * Source is bypassing compiler
-     *
-     * @var boolean
-     */
-    public $uncompiled = null;
-
-    /**
-     * Source must be recompiled on every occasion
-     *
-     * @var boolean
-     */
-    public $recompiled = null;
-
-    /**
-     * The Components an extended template is made of
-     *
-     * @var array
-     */
-    public $components = null;
-
-    /**
-     * Resource Handler
-     *
-     * @var Smarty_Resource
-     */
-    public $handler = null;
-
-    /**
-     * Smarty instance
-     *
-     * @var Smarty
-     */
-    public $smarty = null;
-
-    /**
-     * create Source Object container
-     *
-     * @param Smarty_Resource $handler         Resource Handler this source object communicates with
-     * @param Smarty          $smarty          Smarty instance this source object belongs to
-     * @param string          $resource        full template_resource
-     * @param string          $type            type of resource
-     * @param string          $name            resource name
-     * @param string          $unique_resource unique resource name
-     */
-    public function __construct(Smarty_Resource $handler, Smarty $smarty, $resource, $type, $name, $unique_resource)
-    {
-        $this->handler = $handler; // Note: prone to circular references
-
-        $this->compiler_class = $handler->compiler_class;
-        $this->template_lexer_class = $handler->template_lexer_class;
-        $this->template_parser_class = $handler->template_parser_class;
-        $this->uncompiled = $this->handler instanceof Smarty_Resource_Uncompiled;
-        $this->recompiled = $this->handler instanceof Smarty_Resource_Recompiled;
-
-        $this->smarty = $smarty;
-        $this->resource = $resource;
-        $this->type = $type;
-        $this->name = $name;
-        $this->unique_resource = $unique_resource;
-    }
-
-    /**
-     * get a Compiled Object of this source
-     *
-     * @param  Smarty_Internal_Template|Smarty_Internal_Config $_template template object
-     *
-     * @return Smarty_Template_Compiled compiled object
-     */
-    public function getCompiled($_template)
-    {
-        // check runtime cache
-        $_cache_key = $this->unique_resource . '#' . $_template->compile_id;
-        if (isset(Smarty_Resource::$compileds[$_cache_key])) {
-            return Smarty_Resource::$compileds[$_cache_key];
-        }
-
-        $compiled = new Smarty_Template_Compiled($this);
-        $this->handler->populateCompiledFilepath($compiled, $_template);
-        $compiled->timestamp = @filemtime($compiled->filepath);
-        $compiled->exists = !!$compiled->timestamp;
-
-        // runtime cache
-        Smarty_Resource::$compileds[$_cache_key] = $compiled;
-
-        return $compiled;
-    }
-
-    /**
-     * render the uncompiled source
-     *
-     * @param Smarty_Internal_Template $_template template object
-     */
-    public function renderUncompiled(Smarty_Internal_Template $_template)
-    {
-        return $this->handler->renderUncompiled($this, $_template);
-    }
-
-    /**
-     * <<magic>> Generic Setter.
-     *
-     * @param  string $property_name valid: timestamp, exists, content, template
-     * @param  mixed  $value         new value (is not checked)
-     *
-     * @throws SmartyException if $property_name is not valid
-     */
-    public function __set($property_name, $value)
-    {
-        switch ($property_name) {
-            // regular attributes
-            case 'timestamp':
-            case 'exists':
-            case 'content':
-                // required for extends: only
-            case 'template':
-                $this->$property_name = $value;
-                break;
-
-            default:
-                throw new SmartyException("invalid source property '$property_name'.");
-        }
-    }
-
-    /**
-     * <<magic>> Generic getter.
-     *
-     * @param  string $property_name valid: timestamp, exists, content
-     *
-     * @return mixed
-     * @throws SmartyException if $property_name is not valid
-     */
-    public function __get($property_name)
-    {
-        switch ($property_name) {
-            case 'timestamp':
-            case 'exists':
-                $this->handler->populateTimestamp($this);
-
-                return $this->$property_name;
-
-            case 'content':
-                return $this->content = $this->handler->getContent($this);
-
-            default:
-                throw new SmartyException("source property '$property_name' does not exist.");
-        }
-    }
-}
-
-/**
- * Smarty Resource Data Object
- * Meta Data Container for Template Files
- *
- * @package    Smarty
- * @subpackage TemplateResources
- * @author     Rodney Rehm
- * @property string $content compiled content
- */
-class Smarty_Template_Compiled
-{
-    /**
-     * Compiled Filepath
-     *
-     * @var string
-     */
-    public $filepath = null;
-
-    /**
-     * Compiled Timestamp
-     *
-     * @var integer
-     */
-    public $timestamp = null;
-
-    /**
-     * Compiled Existence
-     *
-     * @var boolean
-     */
-    public $exists = false;
-
-    /**
-     * Compiled Content Loaded
-     *
-     * @var boolean
-     */
-    public $loaded = false;
-
-    /**
-     * Template was compiled
-     *
-     * @var boolean
-     */
-    public $isCompiled = false;
-
-    /**
-     * Source Object
-     *
-     * @var Smarty_Template_Source
-     */
-    public $source = null;
-
-    /**
-     * Metadata properties
-     * populated by Smarty_Internal_Template::decodeProperties()
-     *
-     * @var array
-     */
-    public $_properties = null;
-
-    /**
-     * create Compiled Object container
-     *
-     * @param Smarty_Template_Source $source source object this compiled object belongs to
-     */
-    public function __construct(Smarty_Template_Source $source)
-    {
-        $this->source = $source;
-    }
-}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_adddefaultmodifiers.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_adddefaultmodifiers.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_adddefaultmodifiers.php	(revision )
@@ -0,0 +1,42 @@
+<?php
+
+/**
+ * Smarty Method AddDefaultModifiers
+ *
+ * Smarty::addDefaultModifiers() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_AddDefaultModifiers
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Add default modifiers
+     *
+     * @api Smarty::addDefaultModifiers()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  array|string                                                   $modifiers modifier or list of modifiers
+     *                                                                                   to add
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function addDefaultModifiers(Smarty_Internal_TemplateBase $obj, $modifiers)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (is_array($modifiers)) {
+            $this->default_modifiers = array_merge($smarty->default_modifiers, $modifiers);
+        } else {
+            $smarty->default_modifiers[] = $modifiers;
+        }
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_updatecache.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_updatecache.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_updatecache.php	(revision )
@@ -0,0 +1,170 @@
+<?php
+
+/**
+ * Inline Runtime Methods render, setSourceByUid, setupSubTemplate
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_UpdateCache
+{
+    /**
+     * check client side cache
+     *
+     * @param \Smarty_Template_Cached  $cached
+     * @param Smarty_Internal_Template $_template
+     * @param  string                  $content
+     */
+    public function cacheModifiedCheck(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template, $content)
+    {
+    }
+
+    /**
+     * Sanitize content and write it to cache resource
+     *
+     * @param \Smarty_Template_Cached  $cached
+     * @param Smarty_Internal_Template $_template
+     * @param bool                     $no_output_filter
+     *
+     * @throws \SmartyException
+     */
+    public function removeNoCacheHash(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template,
+                                      $no_output_filter)
+    {
+        $content = ob_get_clean();
+        unset($cached->hashes[$_template->compiled->nocache_hash]);
+        if (!empty($cached->hashes)) {
+            $hash_array = array();
+            foreach ($cached->hashes as $hash => $foo) {
+                $hash_array[] = "/{$hash}/";
+            }
+            $content = preg_replace($hash_array, $_template->compiled->nocache_hash, $content);
+        }
+        $_template->cached->has_nocache_code = false;
+        // get text between non-cached items
+        $cache_split =
+            preg_split("!/\*%%SmartyNocache:{$_template->compiled->nocache_hash}%%\*\/(.+?)/\*/%%SmartyNocache:{$_template->compiled->nocache_hash}%%\*/!s",
+                       $content);
+        // get non-cached items
+        preg_match_all("!/\*%%SmartyNocache:{$_template->compiled->nocache_hash}%%\*\/(.+?)/\*/%%SmartyNocache:{$_template->compiled->nocache_hash}%%\*/!s",
+                       $content, $cache_parts);
+        $content = '';
+        // loop over items, stitch back together
+        foreach ($cache_split as $curr_idx => $curr_split) {
+            // escape PHP tags in template content
+            $content .= preg_replace('/(<%|%>|<\?php|<\?|\?>|<script\s+language\s*=\s*[\"\']?\s*php\s*[\"\']?\s*>)/',
+                                     "<?php echo '\$1'; ?>\n", $curr_split);
+            if (isset($cache_parts[0][$curr_idx])) {
+                $_template->cached->has_nocache_code = true;
+                $content .= $cache_parts[1][$curr_idx];
+            }
+        }
+        if (!$no_output_filter && !$_template->compiled->has_nocache_code &&
+            (isset($_template->smarty->autoload_filters['output']) ||
+                isset($_template->smarty->registered_filters['output']))
+        ) {
+            $content = $_template->smarty->ext->_filterHandler->runFilter('output', $content, $_template);
+        }
+        // write cache file content
+        $this->writeCachedContent($cached, $_template, $content);
+    }
+
+    /**
+     * Cache was invalid , so render from compiled and write to cache
+     *
+     * @param \Smarty_Template_Cached   $cached
+     * @param \Smarty_Internal_Template $_template
+     * @param                           $no_output_filter
+     *
+     * @throws \Exception
+     */
+    public function updateCache(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template, $no_output_filter)
+    {
+        if ($_template->source->handler->uncompiled) {
+            ob_start();
+            $_template->source->render($_template);
+        } else {
+            ob_start();
+            if (!isset($_template->compiled)) {
+                $_template->loadCompiled();
+            }
+            $_template->compiled->render($_template);
+        }
+        if ($_template->smarty->debugging) {
+            $_template->smarty->_debug->start_cache($_template);
+        }
+        $this->removeNoCacheHash($cached, $_template, $no_output_filter);
+        $compile_check = $_template->smarty->compile_check;
+        $_template->smarty->compile_check = false;
+        if (isset($_template->parent) && $_template->parent->_objType == 2) {
+            $_template->compiled->unifunc = $_template->parent->compiled->unifunc;
+        }
+        if (!$_template->cached->processed) {
+            $_template->cached->process($_template, true);
+        }
+        $_template->smarty->compile_check = $compile_check;
+        $cached->getRenderedTemplateCode($_template);
+        if ($_template->smarty->debugging) {
+            $_template->smarty->_debug->end_cache($_template);
+        }
+    }
+
+    /**
+     * Writes the content to cache resource
+     *
+     * @param \Smarty_Template_Cached  $cached
+     * @param Smarty_Internal_Template $_template
+     * @param string                   $content
+     *
+     * @return bool
+     */
+    public function writeCachedContent(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template, $content)
+    {
+        if ($_template->source->handler->recompiled || !($_template->caching == Smarty::CACHING_LIFETIME_CURRENT ||
+                $_template->caching == Smarty::CACHING_LIFETIME_SAVED)
+        ) {
+            // don't write cache file
+            return false;
+        }
+        $content = $_template->smarty->ext->_codeFrame->create($_template, $content, '', true);
+        return $this->write($cached, $_template, $content);
+    }
+
+    /**
+     * Write this cache object to handler
+     *
+     * @param \Smarty_Template_Cached  $cached
+     * @param Smarty_Internal_Template $_template template object
+     * @param string                   $content   content to cache
+     *
+     * @return bool success
+     */
+    public function write(Smarty_Template_Cached $cached, Smarty_Internal_Template $_template, $content)
+    {
+        if (!$_template->source->handler->recompiled) {
+            if ($cached->handler->writeCachedContent($_template, $content)) {
+                $cached->content = null;
+                $cached->timestamp = time();
+                $cached->exists = true;
+                $cached->valid = true;
+                $cached->cache_lifetime = $_template->cache_lifetime;
+                $cached->processed = false;
+                if ($_template->smarty->cache_locking) {
+                    $cached->handler->releaseLock($_template->smarty, $cached);
+                }
+
+                return true;
+            }
+            $cached->content = null;
+            $cached->timestamp = false;
+            $cached->exists = false;
+            $cached->valid = false;
+            $cached->processed = false;
+        }
+
+        return false;
+    }
+
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_php.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_php.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_php.php	(revision )
@@ -0,0 +1,209 @@
+<?php
+/**
+ * Smarty Internal Plugin Compile PHP Expression
+ * Compiles any tag which will output an expression or variable
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Uwe Tews
+ */
+
+/**
+ * Smarty Internal Plugin Compile PHP Expression Class
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ */
+class Smarty_Internal_Compile_Private_Php extends Smarty_Internal_CompileBase
+{
+
+    /**
+     * Attribute definition: Overwrites base class.
+     *
+     * @var array
+     * @see Smarty_Internal_CompileBase
+     */
+    public $required_attributes = array('code', 'type');
+
+    /**
+     * Compiles code for generating output from any expression
+     *
+     * @param array                                 $args      array with attributes from parser
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
+     * @param array                                 $parameter array with compilation parameter
+     *
+     * @return string
+     * @throws \SmartyException
+     */
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
+    {
+        // check and get attributes
+        $_attr = $this->getAttributes($compiler, $args);
+        $compiler->has_code = false;
+        if ($_attr['type'] == 'xml') {
+            $compiler->tag_nocache = true;
+            $save = $compiler->template->compiled->has_nocache_code;
+            $output = addcslashes($_attr['code'], "'\\");
+            $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Tag($compiler->parser, $compiler->processNocacheCode("<?php echo '" .
+                                                                                                                                                                    $output .
+                                                                                                                                                                    "';?>", $compiler, true)));
+            $compiler->template->compiled->has_nocache_code = $save;
+            return '';
+        }
+        if ($_attr['type'] != 'tag') {
+            if ($compiler->php_handling == Smarty::PHP_REMOVE) {
+                return '';
+            } elseif ($compiler->php_handling == Smarty::PHP_QUOTE) {
+                $output = preg_replace_callback('#(<\?(?:php|=)?)|(<%)|(<script\s+language\s*=\s*["\']?\s*php\s*["\']?\s*>)|(\?>)|(%>)|(<\/script>)#i', array($this,
+                                                                                                                                                              'quote'), $_attr['code']);
+                $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Text($output));
+                return '';
+            } elseif ($compiler->php_handling == Smarty::PHP_PASSTHRU || $_attr['type'] == 'unmatched') {
+                $compiler->tag_nocache = true;
+                $save = $compiler->template->compiled->has_nocache_code;
+                $output = addcslashes($_attr['code'], "'\\");
+                $compiler->parser->current_buffer->append_subtree($compiler->parser, new Smarty_Internal_ParseTree_Tag($compiler->parser, $compiler->processNocacheCode("<?php echo '" .
+                                                                                                                                                                        $output .
+                                                                                                                                                                        "';?>", $compiler, true)));
+                $compiler->template->compiled->has_nocache_code = $save;
+                return '';
+            } elseif ($compiler->php_handling == Smarty::PHP_ALLOW) {
+                if (!($compiler->smarty instanceof SmartyBC)) {
+                    $compiler->trigger_template_error('$smarty->php_handling PHP_ALLOW not allowed. Use SmartyBC to enable it', null, true);
+                }
+                $compiler->has_code = true;
+                return $_attr['code'];
+            } else {
+                $compiler->trigger_template_error('Illegal $smarty->php_handling value', null, true);
+            }
+        } else {
+            $compiler->has_code = true;
+            if (!($compiler->smarty instanceof SmartyBC)) {
+                $compiler->trigger_template_error('{php}{/php} tags not allowed. Use SmartyBC to enable them', null, true);
+            }
+            $ldel = preg_quote($compiler->smarty->left_delimiter, '#');
+            $rdel = preg_quote($compiler->smarty->right_delimiter, '#');
+            preg_match("#^({$ldel}php\\s*)((.)*?)({$rdel})#", $_attr['code'], $match);
+            if (!empty($match[2])) {
+                if ('nocache' == trim($match[2])) {
+                    $compiler->tag_nocache = true;
+                } else {
+                    $compiler->trigger_template_error("illegal value of option flag \"{$match[2]}\"", null, true);
+                }
+            }
+            return preg_replace(array("#^{$ldel}\\s*php\\s*(.)*?{$rdel}#",
+                                      "#{$ldel}\\s*/\\s*php\\s*{$rdel}$#"), array('<?php ', '?>'), $_attr['code']);
+        }
+    }
+
+    /**
+     * Lexer code for PHP tags
+     *
+     * This code has been moved from lexer here fo easier debugging and maintenance
+     *
+     * @param $lex
+     */
+    public function parsePhp($lex)
+    {
+        $lex->token = Smarty_Internal_Templateparser::TP_PHP;
+        $close = 0;
+        $lex->taglineno = $lex->line;
+        $closeTag = '?>';
+        if (strpos($lex->value, '<?xml') === 0) {
+            $lex->is_xml = true;
+            $lex->token = Smarty_Internal_Templateparser::TP_NOCACHE;
+            return;
+        } elseif (strpos($lex->value, '<?') === 0) {
+            $lex->phpType = 'php';
+        } elseif (strpos($lex->value, '<%') === 0) {
+            $lex->phpType = 'asp';
+            $closeTag = '%>';
+        } elseif (strpos($lex->value, '%>') === 0) {
+            $lex->phpType = 'unmatched';
+        } elseif (strpos($lex->value, '?>') === 0) {
+            if ($lex->is_xml) {
+                $lex->is_xml = false;
+                $lex->token = Smarty_Internal_Templateparser::TP_NOCACHE;
+                return;
+            }
+            $lex->phpType = 'unmatched';
+        } elseif (strpos($lex->value, '<s') === 0) {
+            $lex->phpType = 'script';
+            $closeTag = '</script>';
+        } elseif (strpos($lex->value, $lex->smarty->left_delimiter) === 0) {
+            if ($lex->isAutoLiteral()) {
+                $lex->token = Smarty_Internal_Templateparser::TP_TEXT;
+                return;
+            }
+            $closeTag = "{$lex->smarty->left_delimiter}/php{$lex->smarty->right_delimiter}";
+            if ($lex->value == $closeTag) {
+                $lex->compiler->trigger_template_error("unexpected closing tag '{$closeTag}'");
+            }
+            $lex->phpType = 'tag';
+        }
+        if ($lex->phpType == 'unmatched') {
+            return;
+        }
+        if (($lex->phpType == 'php' || $lex->phpType == 'asp') &&
+            ($lex->compiler->php_handling == Smarty::PHP_PASSTHRU || $lex->compiler->php_handling == Smarty::PHP_QUOTE)
+        ) {
+            return;
+        }
+        $start = $lex->counter + strlen($lex->value);
+        $body = true;
+        if (preg_match('~' . preg_quote($closeTag, '~') . '~i', $lex->data, $match, PREG_OFFSET_CAPTURE, $start)) {
+            $close = $match[0][1];
+        } else {
+            $lex->compiler->trigger_template_error("missing closing tag '{$closeTag}'");
+        }
+        while ($body) {
+            if (preg_match('~([/][*])|([/][/][^\n]*)|(\'[^\'\\\\]*(?:\\.[^\'\\\\]*)*\')|("[^"\\\\]*(?:\\.[^"\\\\]*)*")~', $lex->data, $match, PREG_OFFSET_CAPTURE, $start)) {
+                $value = $match[0][0];
+                $from = $pos = $match[0][1];
+                if ($pos > $close) {
+                    $body = false;
+                } else {
+                    $start = $pos + strlen($value);
+                    $phpCommentStart = $value == '/*';
+                    if ($phpCommentStart) {
+                        $phpCommentEnd = preg_match('~([*][/])~', $lex->data, $match, PREG_OFFSET_CAPTURE, $start);
+                        if ($phpCommentEnd) {
+                            $pos2 = $match[0][1];
+                            $start = $pos2 + strlen($match[0][0]);
+                        }
+                    }
+                    while ($close > $pos && $close < $start) {
+                        if (preg_match('~' . preg_quote($closeTag, '~') .
+                                       '~i', $lex->data, $match, PREG_OFFSET_CAPTURE, $from)) {
+                            $close = $match[0][1];
+                            $from = $close + strlen($match[0][0]);
+                        } else {
+                            $lex->compiler->trigger_template_error("missing closing tag '{$closeTag}'");
+                        }
+                    }
+                    if ($phpCommentStart && (!$phpCommentEnd || $pos2 > $close)) {
+                        $lex->taglineno = $lex->line + substr_count(substr($lex->data, $lex->counter, $start), "\n");
+                        $lex->compiler->trigger_template_error("missing PHP comment closing tag '*/'");
+                    }
+                }
+            } else {
+                $body = false;
+            }
+        }
+        $lex->value = substr($lex->data, $lex->counter, $close + strlen($closeTag) - $lex->counter);
+    }
+
+    /*
+     * Call back function for $php_handling = PHP_QUOTE
+     *
+     */
+    /**
+     * @param $match
+     *
+     * @return string
+     */
+    private function quote($match)
+    {
+        return htmlspecialchars($match[0], ENT_QUOTES);
+    }
+}
